function MM_findObj(n, d) { //v4.0
  var p,i,x;  if(!d) d=document; if((p=n.indexOf("?"))>0&&parent.frames.length) {
    d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);}
  if(!(x=d[n])&&d.all) x=d.all[n]; for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n];
  for(i=0;!x&&d.layers&&i<d.layers.length;i++) x=MM_findObj(n,d.layers[i].document);
  if(!x && document.getElementById) x=document.getElementById(n); return x;
}


//本函数做用为校验某页面中的某文本框内所输入的值是否负合要求。现在可以完成的校验有：
//		是否为空						“R”
//		是否是一个合法的Email地址		“isEmail”
//		是否是一个日期型数据			“isDate”
//		是否是一个数值型数据			“isNum”
//		是否是在一个在指定范围内的数值型数据	“inRangeXX:YY” ；XX为最小值，YY为最大值
//		
//本函数一次可完成多个字段的校验，使用方法如下：
//本函数参数为三个一组，每个参数组的第一个参数为要检验字段的名称，第二个参数保留，传一个空值即可，
//第三个参数为该字段的数据类型，请参考上面所述的参数值使用，如某字段要求必需输入，则第三个参数为“R”，
//如必需为一Email地址，则第三个参数为“isEmail”，如该字段必需输入，且必需为一Email地址，则第三个参数为“RisEmail”。
//下面举一例子说明：
//
//	假设在页面内有三个文本框，三个文本框的名称分别为："Name","Email","Age","Money"，四个字段的要求分别为：
//	Name:			不能为空，但可以输入任何字符。
//	Email:			不能为空，且必须输入一个Email地址。
//	Age:			不能为空，且必须为数字，且范围必需在18-40之间。
//	Money:			不能为空，且必须为数字，但不指定范围。
//	现在要对这三个字段进行检查，那么函数为：
//		X_validateForm("Name","","R","Email","","RisEmail","Age","","RinRange18:40","Money","","RisNum");
//	如果要配合Form进行检验，可以写在Form的Onsubmit事件中或提交按钮的Onclick事件中;，完整语句如下：
//	onsubmit='return X_validateForm("Name","","R","Email","","RisEmail","Age","","RinRange18:40","Money","","RisNum");'
//
//此函数适用范围：
//此函数只能用来检查文本框控件内的值，且可以适应多文本框名称相同的情况，会对这些文本框都进行检查；
//如想检查列表框等其它控件内的值，可以使用本函数的另一版本，函数名为MM_validateForm()，用法基本一样，只是其不能检查
//多个文本框相同的情况，在这种情况下会提示出错。

function X_validateForm() { //v4.0
  var i,p,q,nm,test,num,min,max,errors='',args=X_validateForm.arguments;
  for (i=0; i<(args.length-2); i+=3) { test=args[i+2]; oval=MM_findObj(args[i]); msg=args[i+1];
	if (!oval) continue;
	if(!(oval instanceof Array)) llength=1;
	else llength=oval.length;
    for(j=0;j<llength;j++) {
		if (llength==1) val=oval;
		else val=oval(j);
	    if (val) { nm=val.name; if ((val=val.value)!="") {
		  if (test.indexOf('isEmail')!=-1) { p=val.indexOf('@');
			if (p<1 || p==(val.length-1)) errors+='- '+(msg==''?nm+' must contain an e-mail address.\n':msg+'\n');
		} else if (test.indexOf('isDate')!=-1) { 
					if (!checkDate(val)) errors+='- '+(msg==''?nm+' must contain a date.(like dd/mm/yyyy")\n':msg+'\n');
			   }
			
			
			   else if (test!='R') {
						if (isNaN(val)) errors+='- '+(msg==''?nm+' must contain a number.\n':msg+'\n');
						if (test.indexOf('inRange') != -1) { p=test.indexOf(':');
						min=test.substring(7,p); max=test.substring(p+1);
						if (parseFloat(val)<parseFloat(min) || parseFloat(max)<parseFloat(val)) errors+='- '+(msg==''?nm+' must contain a number between '+min+' and '+max+'.\n':msg+'\n');
		}
		else if(val<0) errors+='- '+(msg==''?nm+' must contain a positive number.\n':msg+'\n');
		} } else if (test.charAt(0) == 'R') errors += '- '+(msg==''?nm+' is required.\n':msg+'\n'); }
	}  
  } if (errors) alert('请检查下列信息是否填写:\n\n'+errors);
  document.X_returnValue = (errors == '');
  return document.X_returnValue;
}
